Imports syncfusion.Windows.Forms.Grid

Public Class Form1

  Public Sub LoadGrid()
    GridControl1.RowCount = 1
    GridControl1.ColCount = 4

    Dim gsi As New syncfusion.Windows.Forms.Grid.GridStyleInfo
    gsi.CellType = "FormulaCell"
    gsi.Text = "=Sum(B1:C1)"
    '        gsi.Store.SetValue(syncfusion.Windows.Forms.Grid.GridStyleInfoStore.FormatProperty, "0.00%")
    GridControl1.Data.Item(1, 1) = gsi.Store


    Dim gsi2 As New syncfusion.Windows.Forms.Grid.GridStyleInfo
    gsi2.Text = "3"
    GridControl1.Data.Item(1, 2) = gsi2.Store

    Dim gsi3 As New syncfusion.Windows.Forms.Grid.GridStyleInfo
    gsi3.Text = "3"
    GridControl1.Data.Item(1, 3) = gsi3.Store

    Dim gsi4 As New syncfusion.Windows.Forms.Grid.GridStyleInfo
    gsi4.CellType = "FormulaCell"
    gsi4.Text = "=23"
    GridControl1.Data.Item(1, 4) = gsi4.Store

    'GridControl1.Model.Refresh()
    GridControl1.Refresh()

    GridControl1.Model.Options.ActivateCurrentCellBehavior = Windows.Forms.Grid.GridCellActivateAction.DblClickOnCell
    syncfusion.Windows.Forms.Grid.GridFormulaCellRenderer.ForceEditWhenActivated = False
  End Sub

  Public Sub New()
    ' This call is required by the Windows Form Designer.
    InitializeComponent()

    LoadGrid()
  End Sub

  Private Sub GridControl1_CurrentCellStartEditing(ByVal sender As Object, ByVal e As System.ComponentModel.CancelEventArgs) Handles GridControl1.CurrentCellStartEditing
    If GridControl1.CurrentCell.ColIndex = 3 Or GridControl1.CurrentCell.ColIndex = 4 Then
      Console.WriteLine("CurrentCellStartEditingCancelled")
      e.Cancel = True
    End If
  End Sub


  Private Sub GridControl1_CurrentCellValidating(ByVal sender As Object, ByVal e As System.ComponentModel.CancelEventArgs) Handles GridControl1.CurrentCellValidating
    Console.WriteLine("CurrentCellValidating")
  End Sub

  Private Sub GridControl1_CurrentCellAcceptedChanges(ByVal sender As Object, ByVal e As System.ComponentModel.CancelEventArgs) Handles GridControl1.CurrentCellAcceptedChanges
    Console.WriteLine("CurrentCellAcceptedChanges")
    'GridControl1.Refresh()
    'GridControl1.Model.Refresh()
  End Sub


  Private Sub Button1_Click(ByVal sender As Object, ByVal e As System.EventArgs) Handles Button1.Click
    LoadGrid()
  End Sub

  Private Sub GridControl1_QueryCellInfo(ByVal sender As Object, ByVal e As Windows.Forms.Grid.GridQueryCellInfoEventArgs) Handles GridControl1.QueryCellInfo
    If e.RowIndex = 1 And (e.ColIndex = 3 Or e.ColIndex = 4) Then
      e.Style.ReadOnly = True
    End If
  End Sub
End Class
